OGRE-Next: Ogre::v1::Entity Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::Entity Class Reference
Core | Component » Scene

Defines an instance of a discrete, movable object based on a Mesh. More...

`#include <OgreEntity.h>`

Inheritance diagram for Ogre::v1::Entity:
[legend]

## Public Types
typedef set< Entity * >::type | EntitySet
typedef map< unsignedshort, bool >::type | SchemeHardwareAnimMap
enum | VertexDataBindChoice { BIND_ORIGINAL , BIND_SOFTWARE_SKELETAL , BIND_SOFTWARE_MORPH , BIND_HARDWARE_MORPH }
| Identify which vertex data we should be sending to the renderer. More...
Public Types inherited from Ogre::MovableObject
typedef FastArray< MovableObject * > | MovableObjectArray

## Public Member Functions
| ~Entity () override
| Default destructor.
void | _deinitialise ()
| Tear down the internal structures of this Entity, rendering it uninitialised.
const Matrix4 * | _getBoneMatrices () const
| Internal method for retrieving bone matrix information.
bool | _getBuffersMarkedForAnimation () const
| Are buffers already marked as vertex animated?
VertexData * | _getHardwareVertexAnimVertexData () const
| Advanced method to get the hardware morph vertex information.
unsigned short | _getNumBoneMatrices () const
| Internal method for retrieving bone matrix information.
TempBlendedBufferInfo * | _getSkelAnimTempBufferInfo ()
| Advanced method to get the temp buffer information for software skeletal animation.
VertexData * | _getSkelAnimVertexData () const
| Advanced method to get the temporarily blended skeletal vertex information for entities which are software skinned.
VertexData * | _getSoftwareVertexAnimVertexData () const
| Advanced method to get the temporarily blended software vertex animation information.
TempBlendedBufferInfo * | _getVertexAnimTempBufferInfo ()
| Advanced method to get the temp buffer information for software morph animation.
void | _initialise (bool forceReinitialise=false)
| Try to initialise the Entity from the underlying resources.
bool | _isAnimated () const
| Tests if any animation applied to this entity.
bool | _isSkeletonAnimated () const
| Tests if skeleton was animated.
void | _markBuffersUsedForAnimation ()
| Mark just this vertex data as animated.
void | _notifyAttached (Node *parent) override
| Internal method called to notify the object that it has been attached to a node.
void | _updateAnimation ()
| Advanced method to perform all the updates required for an animated entity.
void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | addSoftwareAnimationRequest (bool normalsAlso)
| Add a request for software animation.
VertexDataBindChoice | chooseVertexDataForBinding (bool hasVertexAnim)
| Choose which vertex data to bind to the renderer.
Entity * | clone () const
| Clones this entity and returns a pointer to the clone.
AnimationStateSet * | getAllAnimationStates () const
| For entities based on animated meshes, gets the AnimationState objects for all animations.
bool | getAlwaysUpdateMainSkeleton () const
| The skeleton of the main entity will be updated even if the an LOD entity is being displayed.
AnimationState * | getAnimationState (const String &name) const
| For entities based on animated meshes, gets the AnimationState object for a single animation.
bool | getDisplaySkeleton () const
| Returns whether or not the entity is currently displaying its skeleton.
EdgeData * | getEdgeList ()
| Implement this method to enable stencil shadows.
Entity * | getManualLodLevel (size_t index) const
| Gets a pointer to the entity representing the numbered manual level of detail.
const MeshPtr & | getMesh () const
| Gets the Mesh that this Entity is based on.
const String & | getMovableType () const override
| Returns the type name of this object.
size_t | getNumManualLodLevels () const
| Returns the number of manual levels of detail that this entity supports.
size_t | getNumSubEntities () const
| Retrieves the number of SubEntity objects making up this entity.
OldSkeletonInstance * | getSkeleton () const
| Get this Entity's personal skeleton instance.
const EntitySet * | getSkeletonInstanceSharingSet () const
| Returns a pointer to the set of entities which share a OldSkeletonInstance.
bool | getSkipAnimationStateUpdate () const
| Entity's skeleton's AnimationState will not be automatically updated when set to true.
int | getSoftwareAnimationNormalsRequests () const
| Returns the number of requests that have been made for software animation of normals.
int | getSoftwareAnimationRequests () const
| Returns the number of requests that have been made for software animation.
SubEntity * | getSubEntity (const String &name)
| Gets a pointer to a SubEntity by name.
const SubEntity * | getSubEntity (const String &name) const
SubEntity * | getSubEntity (size_t index)
| Gets a pointer to a SubEntity, ie a part of an Entity.
const SubEntity * | getSubEntity (size_t index) const
bool | getUpdateBoundingBoxFromSkeleton () const
| If true, the skeleton of the entity will be used to update the bounding box for culling.
VertexData * | getVertexDataForBinding (bool casterPass)
| Retrieve the VertexData which should be used for GPU binding.
bool | hasAnimationState (const String &name) const
| Returns whether the AnimationState with the given name exists.
bool | hasEdgeList ()
| Overridden member from ShadowCaster.
bool | hasSkeleton () const
| Returns whether or not this entity is skeletally animated.
bool | hasVertexAnimation () const
| Returns whether or not this entity is either morph or pose animated.
bool | isHardwareAnimationEnabled ()
| Returns whether or not hardware animation is enabled.
bool | isInitialised () const
| Has this Entity been initialised yet?
void | loadingComplete (Resource *res) override
| Resource::Listener hook to notify Entity that a Mesh is (re)loaded.
void | refreshAvailableAnimationState ()
| Updates the internal animation state set to include the latest available animations from the attached skeleton.
void | removeSoftwareAnimationRequest (bool normalsAlso)
| Removes a request for software animation.
void | setAlwaysUpdateMainSkeleton (bool update)
| The skeleton of the main entity will be updated even if the an LOD entity is being displayed.
void | setDatablock (HlmsDatablock *datablock)
| Sets the given HLMS datablock to all SubEntities.
void | setDatablock (IdString datablockName)
| Sets the given HLMS datablock to all SubEntities.
void | setDatablockOrMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the material to use for the whole of this Item.
void | setDisplaySkeleton (bool display)
| Tells the Entity whether or not it should display it's skeleton, if it has one.
void | setMaterial (const MaterialPtr &material)
| Sets the material to use for the whole of this entity.
void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the material to use for the whole of this entity.
void | setPolygonModeOverrideable (bool PolygonModeOverrideable)
| Sets whether the polygon mode of this entire entity may be overridden by the camera detail settings.
void | setRenderQueueGroup (uint8 queueID) override
| Sets the render queue group this entity will be rendered through.
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the RenderQueue subgroup ID for the whole of this entity.
void | setSkipAnimationStateUpdate (bool skip)
| Entity's skeleton's AnimationState will not be automatically updated when set to true.
void | setUpdateBoundingBoxFromSkeleton (bool update)
| If true, the skeleton of the entity will be used to update the bounding box for culling.
void | shareSkeletonInstanceWith (Entity *entity)
| Shares the OldSkeletonInstance with the supplied entity.
bool | sharesSkeletonInstance () const
| Returns whether this entity shares it's SkeltonInstance with other entity instances.
void | stopSharingSkeletonInstance ()
| Stops sharing the OldSkeletonInstance with other entities.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, uint8 renderQueueId)
| Constructor.
| MovableObject (ObjectData *objectDataPtrs)
| Don't use this constructor unless you know what you're doing.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager () const
| Get the manager of this object, if any (internal use only).
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state.
const Matrix4 & | _getParentNodeFullTransform () const
| Returns the full transformation of the parent sceneNode or the attachingPoint node.
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyParentNodeMemoryChanged ()
virtual void | _notifyStaticDirty () const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent ()
| Detaches an object from a parent SceneNode if attached.
RealAsUint | getCachedDistanceToCamera () const
| Returns the distance to camera as calculated in cullFrustum().
Real | getCachedDistanceToCameraAsReal () const
| Returns the distance to camera as calculated in cullFrustum().
bool | getCastShadows () const
| Returns whether shadow casting is enabled for this object.
unsigned char | getCurrentMeshLod () const
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener () const
| Gets the current listener for this object.
Aabb | getLocalAabb () const
| Retrieves the local axis-aligned bounding box for this object.
float | getLocalRadius () const
| See getLocalAabb and getWorldRadius.
const String & | getName () const
| Returns the name of this object.
Node * | getParentNode () const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode () const
uint32 | getQueryFlags () const
| Returns the query flags relevant for this object.
Real | getRenderingDistance () const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup () const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
Real | getShadowRenderingDistance () const
| Gets the distance at which batches are no longer casting shadows.
SkeletonInstance * | getSkeletonInstance () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
uint32 | getVisibilityFlags () const
| Returns the visibility flags relevant for this object.
bool | getVisible () const
| Gets this object whether to be visible or not, if it has a renderable component.
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space.
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space.
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
bool | isAttached () const
| Returns true if this object is attached to a Node.
bool | isStatic () const
| Checks whether this MovableObject is static.
bool | isVisible () const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights () const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object.
void | setName (const String &name)
| Sets a custom name for this node.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows.
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic.
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
const StringVector & | getAnimableValueNames () const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
Public Member Functions inherited from Ogre::Resource::Listener
| Listener ()
virtual | ~Listener ()
virtual void | preparingComplete (Resource *)
| Called whenever the resource finishes preparing (paging into memory).
virtual void | unloadingComplete (Resource *)
| Called whenever the resource has been unloaded.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| See SceneManager::cullLights & see MovableObject::cullFrustum.
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static void | updateAllBounds (const size_t numNodes, ObjectData t)
Public Attributes inherited from Ogre::MovableObject
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).
RenderableArray | mRenderables
Static Public Attributes inherited from Ogre::MovableObject
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

Defines an instance of a discrete, movable object based on a Mesh.

Remarks
  Ogre generally divides renderable objects into 2 groups, discrete (separate) and relatively small objects which move around the world, and large, sprawling geometry which makes up generally immovable scenery, aka 'level geometry'.

  The Mesh and SubMesh classes deal with the definition of the geometry used by discrete movable objects. Entities are actual instances of objects based on this geometry in the world. Therefore there is usually a single set Mesh for a car, but there may be multiple entities based on it in the world. Entities are able to override aspects of the Mesh it is defined by, such as changing material properties per instance (so you can have many cars using the same geometry but different textures for example). Because a Mesh is split into SubMeshes for this purpose, the Entity class is a grouping class (much like the Mesh class) and much of the detail regarding individual changes is kept in the SubEntity class. There is a 1:1 relationship between SubEntity instances and the SubMesh instances associated with the Mesh the Entity is based on.

  Entity and SubEntity classes are never created directly. Use the createEntity method of the SceneManager (passing a model name) to create one.

  Entities are included in the scene by associating them with a SceneNode, using the attachEntity method. See the SceneNode class for full information.

Note
  No functions were declared virtual to improve performance.

## Member Typedef Documentation

## ◆ EntitySet

typedef set<Entity*>::type Ogre::v1::Entity::EntitySet

## ◆ SchemeHardwareAnimMap

typedef map<unsignedshort,bool>::type Ogre::v1::Entity::SchemeHardwareAnimMap

## Member Enumeration Documentation

## ◆ VertexDataBindChoice

enum Ogre::v1::Entity::VertexDataBindChoice

Identify which vertex data we should be sending to the renderer.

Enumerator
BIND_ORIGINAL |
BIND_SOFTWARE_SKELETAL |
BIND_SOFTWARE_MORPH |
BIND_HARDWARE_MORPH |

## Constructor & Destructor Documentation

## ◆ ~Entity()

Ogre::v1::Entity::~Entity | ( |  | ) |
| override

Default destructor.

## Member Function Documentation

## ◆ _deinitialise()

void Ogre::v1::Entity::_deinitialise | ( |  | ) |

Tear down the internal structures of this Entity, rendering it uninitialised.

## ◆ _getBoneMatrices()

const Matrix4 * Ogre::v1::Entity::_getBoneMatrices | ( |  | ) | const
| inline

Internal method for retrieving bone matrix information.

## ◆ _getBuffersMarkedForAnimation()

bool Ogre::v1::Entity::_getBuffersMarkedForAnimation | ( |  | ) | const
| inline

Are buffers already marked as vertex animated?

## ◆ _getHardwareVertexAnimVertexData()

VertexData * Ogre::v1::Entity::_getHardwareVertexAnimVertexData | ( |  | ) | const

Advanced method to get the hardware morph vertex information.

Note
  The positions/normals of the returned vertex data is in object space.

## ◆ _getNumBoneMatrices()

unsigned short Ogre::v1::Entity::_getNumBoneMatrices | ( |  | ) | const
| inline

Internal method for retrieving bone matrix information.

## ◆ _getSkelAnimTempBufferInfo()

TempBlendedBufferInfo * Ogre::v1::Entity::_getSkelAnimTempBufferInfo | ( |  | ) |

Advanced method to get the temp buffer information for software skeletal animation.

## ◆ _getSkelAnimVertexData()

VertexData * Ogre::v1::Entity::_getSkelAnimVertexData | ( |  | ) | const

Advanced method to get the temporarily blended skeletal vertex information for entities which are software skinned.

Remarks
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via addSoftwareAnimationRequest.

Note
  The positions/normals of the returned vertex data is in object space.

## ◆ _getSoftwareVertexAnimVertexData()

VertexData * Ogre::v1::Entity::_getSoftwareVertexAnimVertexData | ( |  | ) | const

Advanced method to get the temporarily blended software vertex animation information.

Remarks
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via addSoftwareAnimationRequest.

Note
  The positions/normals of the returned vertex data is in object space.

## ◆ _getVertexAnimTempBufferInfo()

TempBlendedBufferInfo * Ogre::v1::Entity::_getVertexAnimTempBufferInfo | ( |  | ) |

Advanced method to get the temp buffer information for software morph animation.

## ◆ _initialise()

void Ogre::v1::Entity::_initialise | ( | bool | forceReinitialise = false | ) |

Try to initialise the Entity from the underlying resources.

Remarks
  This method builds the internal structures of the Entity based on it resources (Mesh, Skeleton). This may or may not succeed if the resources it references have been earmarked for background loading, so you should check isInitialised afterwards to see if it was successful.

Parameters

  forceReinitialise | If `true`, this forces the Entity to tear down it's internal structures and try to rebuild them. Useful if you changed the content of a Mesh or Skeleton at runtime.

## ◆ _isAnimated()

bool Ogre::v1::Entity::_isAnimated | ( |  | ) | const

Tests if any animation applied to this entity.

Remarks
  An entity is animated if any animation state is enabled, or any manual bone applied to the skeleton.

## ◆ _isSkeletonAnimated()

bool Ogre::v1::Entity::_isSkeletonAnimated | ( |  | ) | const

Tests if skeleton was animated.

## ◆ _markBuffersUsedForAnimation()

void Ogre::v1::Entity::_markBuffersUsedForAnimation | ( |  | ) |

Mark just this vertex data as animated.

## ◆ _notifyAttached()

void Ogre::v1::Entity::_notifyAttached | ( | Node * | parent | ) |
| overridevirtual

Internal method called to notify the object that it has been attached to a node.

Reimplemented from Ogre::MovableObject.

## ◆ _updateAnimation()

void Ogre::v1::Entity::_updateAnimation | ( |  | ) |

Advanced method to perform all the updates required for an animated entity.

Remarks
  You don't normally need to call this, but it's here in case you wish to manually update the animation of an Entity at a specific point in time. Animation will not be updated more than once a frame no matter how many times you call this method.

## ◆ _updateRenderQueue()

void Ogre::v1::Entity::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Reimplemented from Ogre::MovableObject.

## ◆ addSoftwareAnimationRequest()

void Ogre::v1::Entity::addSoftwareAnimationRequest | ( | bool | normalsAlso | ) |

Add a request for software animation.

Remarks
  Tells the entity to perform animation calculations for skeletal/vertex animations in software, regardless of the current setting of isHardwareAnimationEnabled(). Software animation will be performed any time one or more requests have been made. If 'normalsAlso' is 'true', then the entity will also do software blending on normal vectors, in addition to positions. This advanced method useful for situations in which access to actual mesh vertices is required, such as accurate collision detection or certain advanced shading techniques. When software animation is no longer needed, the caller of this method should always remove the request by calling removeSoftwareAnimationRequest(), passing the same value for 'normalsAlso'.

## ◆ chooseVertexDataForBinding()

VertexDataBindChoice Ogre::v1::Entity::chooseVertexDataForBinding | ( | bool | hasVertexAnim | ) |

Choose which vertex data to bind to the renderer.

## ◆ clone()

Entity * Ogre::v1::Entity::clone | ( |  | ) | const

Clones this entity and returns a pointer to the clone.

Remarks
  Useful method for duplicating an entity. The new entity must be given a unique name, and is not attached to the scene in any way so must be attached to a SceneNode to be visible (exactly as entities returned from SceneManager::createEntity).

Parameters

  newName | Name for the new entity.

## ◆ getAllAnimationStates()

AnimationStateSet * Ogre::v1::Entity::getAllAnimationStates | ( |  | ) | const

For entities based on animated meshes, gets the AnimationState objects for all animations.

Returns
  In case the entity is animated, this functions returns the pointer to a AnimationStateSet containing all animations of the entries. If the entity is not animated, it returns 0.

Remarks
  You animate an entity by updating the animation state objects. Each of these represents the current state of each animation available to the entity. The AnimationState objects are initialised from the Mesh object.

## ◆ getAlwaysUpdateMainSkeleton()

bool Ogre::v1::Entity::getAlwaysUpdateMainSkeleton | ( |  | ) | const
| inline

The skeleton of the main entity will be updated even if the an LOD entity is being displayed.

useful if you have entities attached to the main entity. Otherwise position of attached entities will not be updated.

## ◆ getAnimationState()

AnimationState * Ogre::v1::Entity::getAnimationState | ( | const String & | name | ) | const

For entities based on animated meshes, gets the AnimationState object for a single animation.

Remarks
  You animate an entity by updating the animation state objects. Each of these represents the current state of each animation available to the entity. The AnimationState objects are initialised from the Mesh object.

## ◆ getDisplaySkeleton()

bool Ogre::v1::Entity::getDisplaySkeleton | ( |  | ) | const

Returns whether or not the entity is currently displaying its skeleton.

## ◆ getEdgeList()

EdgeData * Ogre::v1::Entity::getEdgeList | ( |  | ) |

Implement this method to enable stencil shadows.

## ◆ getManualLodLevel()

Entity * Ogre::v1::Entity::getManualLodLevel | ( | size_t | index | ) | const

Gets a pointer to the entity representing the numbered manual level of detail.

Remarks
  The zero-based index never includes the original entity, unlike Mesh::getLodLevel.

## ◆ getMesh()

const MeshPtr & Ogre::v1::Entity::getMesh | ( |  | ) | const

Gets the Mesh that this Entity is based on.

## ◆ getMovableType()

const String & Ogre::v1::Entity::getMovableType | ( |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getNumManualLodLevels()

size_t Ogre::v1::Entity::getNumManualLodLevels | ( |  | ) | const

Returns the number of manual levels of detail that this entity supports.

Remarks
  This number never includes the original entity, it is difference with Mesh::getNumLodLevels.

## ◆ getNumSubEntities()

size_t Ogre::v1::Entity::getNumSubEntities | ( |  | ) | const

Retrieves the number of SubEntity objects making up this entity.

## ◆ getSkeleton()

OldSkeletonInstance * Ogre::v1::Entity::getSkeleton | ( |  | ) | const
| inline

Get this Entity's personal skeleton instance.

## ◆ getSkeletonInstanceSharingSet()

const EntitySet * Ogre::v1::Entity::getSkeletonInstanceSharingSet | ( |  | ) | const
| inline

Returns a pointer to the set of entities which share a OldSkeletonInstance.

If this instance does not share it's OldSkeletonInstance with other instances `NULL` will be returned

## ◆ getSkipAnimationStateUpdate()

bool Ogre::v1::Entity::getSkipAnimationStateUpdate | ( |  | ) | const
| inline

Entity's skeleton's AnimationState will not be automatically updated when set to true.

Useful if you wish to handle AnimationState updates manually.

## ◆ getSoftwareAnimationNormalsRequests()

int Ogre::v1::Entity::getSoftwareAnimationNormalsRequests | ( |  | ) | const
| inline

Returns the number of requests that have been made for software animation of normals.

Remarks
  If non-zero, and getSoftwareAnimationRequests() also returns non-zero, then software animation of normals will be performed in updateAnimation regardless of the current setting of isHardwareAnimationEnabled or any internal optimise for eliminate software animation. Currently it is not possible to force software animation of only normals. Consequently this value is always less than or equal to that returned by getSoftwareAnimationRequests(). Requests for software animation of normals are made by calling the addSoftwareAnimationRequest() method with 'true' as the parameter.

## ◆ getSoftwareAnimationRequests()

int Ogre::v1::Entity::getSoftwareAnimationRequests | ( |  | ) | const
| inline

Returns the number of requests that have been made for software animation.

Remarks
  If non-zero then software animation will be performed in updateAnimation regardless of the current setting of isHardwareAnimationEnabled or any internal optimise for eliminate software animation. Requests for software animation are made by calling the addSoftwareAnimationRequest() method.

## ◆ getSubEntity() [1/4]

SubEntity * Ogre::v1::Entity::getSubEntity | ( | const String & | name | ) |

Gets a pointer to a SubEntity by name.

Remarks
  Names should be initialized during a Mesh creation.

References SubEntity.

## ◆ getSubEntity() [2/4]

const SubEntity * Ogre::v1::Entity::getSubEntity | ( | const String & | name | ) | const

References SubEntity.

## ◆ getSubEntity() [3/4]

SubEntity * Ogre::v1::Entity::getSubEntity | ( | size_t | index | ) |

Gets a pointer to a SubEntity, ie a part of an Entity.

References SubEntity.

## ◆ getSubEntity() [4/4]

const SubEntity * Ogre::v1::Entity::getSubEntity | ( | size_t | index | ) | const

References SubEntity.

## ◆ getUpdateBoundingBoxFromSkeleton()

bool Ogre::v1::Entity::getUpdateBoundingBoxFromSkeleton | ( |  | ) | const
| inline

If true, the skeleton of the entity will be used to update the bounding box for culling.

Useful if you have skeletal animations that move the bones away from the root. Otherwise, the bounding box of the mesh in the binding pose will be used.

## ◆ getVertexDataForBinding()

VertexData * Ogre::v1::Entity::getVertexDataForBinding | ( | bool | casterPass | ) |

Retrieve the VertexData which should be used for GPU binding.

## ◆ hasAnimationState()

bool Ogre::v1::Entity::hasAnimationState | ( | const String & | name | ) | const

Returns whether the AnimationState with the given name exists.

## ◆ hasEdgeList()

bool Ogre::v1::Entity::hasEdgeList | ( |  | ) |

Overridden member from ShadowCaster.

## ◆ hasSkeleton()

bool Ogre::v1::Entity::hasSkeleton | ( |  | ) | const
| inline

Returns whether or not this entity is skeletally animated.

## ◆ hasVertexAnimation()

bool Ogre::v1::Entity::hasVertexAnimation | ( |  | ) | const

Returns whether or not this entity is either morph or pose animated.

## ◆ isHardwareAnimationEnabled()

bool Ogre::v1::Entity::isHardwareAnimationEnabled | ( |  | ) |

Returns whether or not hardware animation is enabled.

Remarks
  Because fixed-function indexed vertex blending is rarely supported by existing graphics cards, hardware animation can only be done if the vertex programs in the materials used to render an entity support it. Therefore, this method will only return true if all the materials assigned to this entity have vertex programs assigned, and all those vertex programs must support 'includes_morph_animation true' if using morph animation, 'includes_pose_animation true' if using pose animation and 'includes_skeletal_animation true' if using skeletal animation.

Also note the the function returns value according to the current active scheme. This is due to the fact that RTSS schemes may be different in their handling of hardware animation.

## ◆ isInitialised()

bool Ogre::v1::Entity::isInitialised | ( |  | ) | const
| inline

Has this Entity been initialised yet?

Remarks
  If this returns false, it means this Entity hasn't been completely constructed yet from the underlying resources (Mesh, Skeleton), which probably means they were delay-loaded and aren't available yet. This Entity won't render until it has been successfully initialised, nor will many of the manipulation methods function.

## ◆ loadingComplete()

void Ogre::v1::Entity::loadingComplete | ( | Resource * | res | ) |
| overridevirtual

Resource::Listener hook to notify Entity that a Mesh is (re)loaded.

Reimplemented from Ogre::Resource::Listener.

## ◆ refreshAvailableAnimationState()

void Ogre::v1::Entity::refreshAvailableAnimationState | ( |  | ) |

Updates the internal animation state set to include the latest available animations from the attached skeleton.

Remarks
  Use this method if you manually add animations to a skeleton, or have linked the skeleton to another for animation purposes since creating this entity.

Note
  If you have called getAnimationState prior to calling this method, the pointers will still remain valid.

## ◆ removeSoftwareAnimationRequest()

void Ogre::v1::Entity::removeSoftwareAnimationRequest | ( | bool | normalsAlso | ) |

Removes a request for software animation.

Remarks
  Calling this decrements the entity's internal counter of the number of requests for software animation. If the counter is already zero then calling this method throws an exception. The 'normalsAlso' flag if set to 'true' will also decrement the internal counter of number of requests for software animation of normals.

## ◆ setAlwaysUpdateMainSkeleton()

void Ogre::v1::Entity::setAlwaysUpdateMainSkeleton | ( | bool | update | ) |
| inline

The skeleton of the main entity will be updated even if the an LOD entity is being displayed.

useful if you have entities attached to the main entity. Otherwise position of attached entities will not be updated.

## ◆ setDatablock() [1/2]

void Ogre::v1::Entity::setDatablock | ( | HlmsDatablock * | datablock | ) |

Sets the given HLMS datablock to all SubEntities.

## ◆ setDatablock() [2/2]

void Ogre::v1::Entity::setDatablock | ( | IdString | datablockName | ) |

Sets the given HLMS datablock to all SubEntities.

## ◆ setDatablockOrMaterialName()

void Ogre::v1::Entity::setDatablockOrMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Sets the material to use for the whole of this Item.

Remarks
  This is a shortcut method to set all the materials for all subentities of this Item. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubItem() and call the same method on the individual SubItem.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ setDisplaySkeleton()

void Ogre::v1::Entity::setDisplaySkeleton | ( | bool | display | ) |

Tells the Entity whether or not it should display it's skeleton, if it has one.

## ◆ setMaterial()

void Ogre::v1::Entity::setMaterial | ( | const MaterialPtr & | material | ) |

Sets the material to use for the whole of this entity.

Remarks
  This is a shortcut method to set all the materials for all subentities of this entity. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

## ◆ setMaterialName()

void Ogre::v1::Entity::setMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Sets the material to use for the whole of this entity.

Remarks
  This is a shortcut method to set all the materials for all subentities of this entity. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ setPolygonModeOverrideable()

void Ogre::v1::Entity::setPolygonModeOverrideable | ( | bool | PolygonModeOverrideable | ) |

Sets whether the polygon mode of this entire entity may be overridden by the camera detail settings.

## ◆ setRenderQueueGroup()

void Ogre::v1::Entity::setRenderQueueGroup | ( | uint8 | queueID | ) |
| overridevirtual

Sets the render queue group this entity will be rendered through.

Remarks
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

  Valid render queue ids are between 0 & 254 inclusive

Reimplemented from Ogre::MovableObject.

## ◆ setRenderQueueSubGroup()

void Ogre::v1::Entity::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |

Sets the RenderQueue subgroup ID for the whole of this entity.

Remarks
  This is a shortcut method to set all the subgroups for all subentities of this entity. Only use this method is you want to set the same subgroup for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

## ◆ setSkipAnimationStateUpdate()

void Ogre::v1::Entity::setSkipAnimationStateUpdate | ( | bool | skip | ) |
| inline

Entity's skeleton's AnimationState will not be automatically updated when set to true.

Useful if you wish to handle AnimationState updates manually.

## ◆ setUpdateBoundingBoxFromSkeleton()

void Ogre::v1::Entity::setUpdateBoundingBoxFromSkeleton | ( | bool | update | ) |

If true, the skeleton of the entity will be used to update the bounding box for culling.

Useful if you have skeletal animations that move the bones away from the root. Otherwise, the bounding box of the mesh in the binding pose will be used.

Remarks
  When true, the bounding box will be generated to only enclose the bones that are used for skinning. Also the resulting bounding box will be expanded by the amount of GetMesh()->getBoneBoundingRadius(). The expansion amount can be changed on the mesh to achieve a better fitting bounding box.

## ◆ shareSkeletonInstanceWith()

void Ogre::v1::Entity::shareSkeletonInstanceWith | ( | Entity * | entity | ) |

Shares the OldSkeletonInstance with the supplied entity.

Note that in order for this to work, both entities must have the same Skeleton.

## ◆ sharesSkeletonInstance()

bool Ogre::v1::Entity::sharesSkeletonInstance | ( |  | ) | const
| inline

Returns whether this entity shares it's SkeltonInstance with other entity instances.

## ◆ stopSharingSkeletonInstance()

void Ogre::v1::Entity::stopSharingSkeletonInstance | ( |  | ) |

Stops sharing the OldSkeletonInstance with other entities.

The documentation for this class was generated from the following file:

- OgreEntity.h